/********************************************************************************************************
* PROGRAM      : fgPlugins
* DATE - TIME  : mardi 25 juillet 2006 - 18h57
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox@gmail.com )
* FILENAME     : fgDialog.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef FGDIALOG_H
#define FGDIALOG_H
//
#include <QDialog>
#include <QPixmap>
#include <QVariant>
//
class QEvent;
class QMouseEvent;
//
class fgDialog : public QDialog
{
	Q_OBJECT
	//
public:
	Q_PROPERTY( bool autoResize READ autoResize WRITE setAutoResize )
	Q_PROPERTY( QVariant data READ data WRITE setData )
	Q_PROPERTY( bool movable READ movable WRITE setMovable )
	Q_PROPERTY( QPixmap backgroundPixmap READ backgroundPixmap WRITE setBackgroundPixmap )
	//
	fgDialog( QWidget* = 0, Qt::WindowFlags = Qt::Dialog | Qt::FramelessWindowHint );
	//
	const QPoint mouse() const;
	const bool autoResize() const;
	const QVariant data() const;
	const bool movable() const;
	const QPixmap backgroundPixmap() const;
	static void fixMacWidgets( QWidget* parent );
	//
public slots:
	void fixMacWidgets();
	void setMouse( const QPoint& );
	void setAutoResize( const bool );
	void setData( const QVariant& );
	void setMovable( const bool );
	void setBackgroundPixmap( const QPixmap& );
	void setWidgetTransparent( QWidget*, const QPixmap&, bool = true, QPalette::ColorRole = QPalette::Base );
	//
protected:
	virtual void mouseMoveEvent ( QMouseEvent* );
	virtual void mousePressEvent ( QMouseEvent* );
	//
signals:
	void dataChanged();
	void dataChanged( const QVariant& );
	void dataChanged( const QString& );
	void dataChanged( const int );
	//
private:
	QPoint mMouse;
	bool _autoResize;
	QVariant _data;
	bool _movable;
	QPixmap _backgroundPixmap;
	//
};
//
#endif // FGDIALOG_H
