// ### ChannelsGrabber.cpp ###

#include "ChannelsGrabber.h"
//#include "FreeGoEvents.h"
#include "main.h"
#include "misc.h"
//#include "ui/AlertForm.h"
#include "ui/UIMain.h"
#include <QIcon>
#include <QPixmap>

// ### Constructor ###
ChannelsGrabber::ChannelsGrabber()
{
	// Signaux
	connect(&http, SIGNAL(done(bool)), this, SLOT(processChannels()));
	
	// Requete HTTP de recup des chaines
	http.setHost("www.free-go.net");
	http.get( "/listemenu.php" );
}

// ### Slot principal ###
void ChannelsGrabber::processChannels()
{
	QString 	buf 	= QString::fromUtf8( http.readAll() );
	QStringList blocks 	= buf.split( "\n" );
	QString 	line;
	
	for (int i=0; i<blocks.count()-1; i+=2)
	{
		Channel 	channel;
		QStringList fields = blocks.at(i).split("*");
		
		// Channel values
		channel.index	= fields.at(0).trimmed();
		channel.name 	= fields.at(1).trimmed();
		channel.url 	= blocks.at(i+1).trimmed();
	
		if (fields.count() > 2)
		{
			channel.theme = fields.at(2);
		}	
		
		chanList.append(channel);
	}
	emit completed();
}

// ### Recuperations des Chaines ###
QList<Channel> ChannelsGrabber::getChannels()
{
	return chanList;
}

// ### Menu des Chaines, avec icones ###
QMenu* ChannelsGrabber::getChannelsMenu()
{
	QMenu *menuTV = new QMenu(QString::fromUtf8("Télévision"));
	menuTV->setIcon(QIcon(":/Buttons/Images/Buttons/systray_configuration.png"));
	QMenu *menu = menuTV->addMenu(QString::fromUtf8("Chaînes"));
	menuTV->addAction( QIcon(":/Buttons/Images/Buttons/systray_configuration.png"), "Programmation", UIMain::self(), SLOT( showTelevision() ) );
	QMap<QString, QMenu *> map;
	QMenu *sousMenu;
	
	for(int i=0; i<channels.count(); i++)
	{
		QString icopath = channels.at(i).toLower();
		icopath.replace(" ", "");
		//
		QHttp *http = new QHttp(this);
		connect(http, SIGNAL(done(bool)), this, SLOT(slotSupprimeHttp(bool)) );
		http->setHost("www.free-go.net");
		QString requete = QString("/chan/%1.png").arg(urls.at(i).section("/",-1,-1) );
		http->get( requete );
		//
		QAction *chanAct = new QAction(channels.at(i), this);
		chanAct->setData(urls.at(i));		
		
		if (map.contains(themes.at(i)) )
			sousMenu = map.value(themes.at(i));
		else
		{
			sousMenu = new QMenu(themes.at(i));
			QHttp *http2 = new QHttp(this);
			connect(http2, SIGNAL(done(bool)), this, SLOT(slotSupprimeHttp(bool)) );
			http2->setHost("www.free-go.net");
			QString requete = "/chan/"+themes.at(i)+".png";
			http2->get( requete );
			requeteIconeMenu[http2] = sousMenu;
			menu->addMenu(sousMenu );
			map[themes.at(i)] = sousMenu;
		}
		sousMenu->addAction(chanAct);
		requeteIcone[http] = chanAct;
	}

	menu->setWindowFlags(Qt::Popup);
	//menu->setTearOffEnabled(true);
	//menu->setMaximumSize(100, 300);
	return menuTV;
}

//
void ChannelsGrabber::slotSupprimeHttp( bool /*erreur*/ )
{
	QHttp *http = (QHttp *)sender();
	QByteArray array = http->readAll();
	QPixmap pix;
	if( array.length() )
		pix.loadFromData((unsigned char *)array.data(), array.length());
	QAction *action = requeteIcone.value(http);
	if( action )
		action->setIcon( pix );
	else
	{
		QMenu *menu = requeteIconeMenu.value(http);
		if( menu )
			menu->setIcon( pix );
	}
	http->deleteLater();
}
