/*
	Asyn TV Grabber
*/
#ifndef CHANNELSGRABBER_H
#define CHANNELSGRABBER_H

#include <QAction>
#include <QBuffer>
#include <QHttp>
#include <QIcon>
#include <QMenu>
#include <QStringList>
#include <QMap>
#include <QPointer>
#include <QSettings>
#include <QUrl>
#include <QtNetwork/QHttpResponseHeader>


// D�finition d'une structure Channel bien commode :)
typedef struct channel
{
	QString index;
	QString	name;
	QString	theme;
	QString	url;
	QIcon	*icon;
	
} Channel;


class ChannelsGrabber : public QObject
{
	Q_OBJECT
public:
	ChannelsGrabber();
	QMenu*			getChannelsMenu();
	QList<Channel>	getChannels();
	
signals:
	void		completed();
	
public slots:
	void 		processChannels();

private slots:
	void slotSupprimeHttp(bool erreur);
private:
	QStringList	channels, urls, themes;	
	QHttp 		http;
	QBuffer    	rawData;

	bool		locked;
	QMap<QHttp *, QAction *> requeteIcone;
	QMap<QHttp *, QMenu *> requeteIconeMenu;

	// Channels list
	QList<Channel> chanList;
};

#endif
