/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : mardi 25 juillet 2006 - 19h39
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox@gmail.com )
* FILENAME     : UIMain.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef UIMAIN_H
#define UIMAIN_H
//
#include "ui_UIMain.h"
//
#include <QPointer>
#if QT_VERSION >= 0x040200
#include <QSystemTrayIcon>
#endif
//
class QMenu;
class QAction;
//
class UIMain : public fgDialog, public Ui::UIMain
{
	Q_OBJECT
	//
public:
	static UIMain* self( QWidget* = 0 );
	//

private:
	UIMain( QWidget* = 0 );
	static QPointer<UIMain> mSelf;
	bool mInit;
	bool mSmall;
#if QT_VERSION >= 0x040200
	QSystemTrayIcon* mTray;
	QMenu* mTrayMenu;
	QMenu* mTrayEmails;
#endif
	//
protected:
	void showEvent( QShowEvent* );
	void closeEvent( QCloseEvent* );
	bool showLineFeatures() const;
	//
public slots:
	virtual void reject();
#if QT_VERSION >= 0x040200
	void activated( QSystemTrayIcon::ActivationReason );
#endif
	void alert( const QString& );
	void refreshCombos();
	void updateProgram( const QString&, bool );
	void openMailBox( QAction* );
	void setSmall( bool );
	void setShowLineFeatures( bool );
	//
	void on_fgLogo_clicked();
	void on_fgSmall_clicked();
	void on_fgSystray_clicked();
	//
	void on_cbFreeAccounts_activated( const QString& );
	void on_fgGoEmail_clicked();
	void on_fgMonitor_clicked();
	void on_fgConfigure_clicked();
	void on_fgRooterWifi_clicked();
	void on_fgPhone_clicked();
	void on_fgTV_clicked();
	void on_fgInvoice_clicked();
	void on_fgSubscribe_clicked();
	void on_fgRate_clicked();
	void on_fgNetwork_clicked();
	void on_fgEmail_clicked();
	//
};
//
#endif // UIMAIN_H
