/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : mardi 01 aot 2006 - 19h23
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UINotify.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef NOTIFIERFORM_H
#define NOTIFIERFORM_H

#include "ui_UINotify.h"

#include <QPointer>
#include <QTimer>

class QUrl;

class UINotify : public fgDialog, public Ui::UINotify
{
	Q_OBJECT

public:
	enum NotifyType {
		ntAlert = 0,
		ntNewEmails,
		ntProgramUpdate,
		ntProgramUpdating,
		ntFreeBoxUpdate,
		ntFreeActualityUpdate,
		ntTeamMessageUpdate,
		ntFreeGoAnnonce,
		ntTelephonyMessage
	};
	UINotify( UINotify::NotifyType, QWidget* = 0 );

	void setType( UINotify::NotifyType );
	NotifyType type() const;

protected:
	virtual void moveEvent( QMoveEvent* );

public slots:
	void setPixmaps( const QString&, const QString&, const QString& );
	void on_tbInformations_anchorClicked( const QUrl& );

private:
	static QPointer<UINotify> mLastUINotify;
	NotifyType mType;
};

// NOTIFY Class
class Notify : public QObject
{
	Q_OBJECT
public:
	static Notify* self( QObject* = 0 );

private:
	Notify( QObject* = 0 );
	static QPointer<Notify> mSelf;

public slots:
	// alert
	void alert( const QString& );
	// MailChecker
	void newEmails( const QString&, int );
	// FreeGoInformations, validity, version, msg
	void programUpdate( int, const QDateTime&, const QString& );
	void programUpdating( int, const QDateTime&, const QString& );
	void freeboxUpdate( int, const QDateTime&, const QString& );
	void freeActualityUpdate( int, const QDateTime&, const QString& );
	void teamMessageUpdate( int, const QDateTime&, const QString& );
	void freegoAnnonce( int, const QDateTime&, const QString&, const QString& );
	void newMessages( int count );
};

#endif  // NOTIFIERFORM_H
