/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : dimanche 01 octobre 2006 - 16h00
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UIPublicity.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef UIPUBLICITY_H
#define UIPUBLICITY_H

#include "ui_UIPublicity.h"

#include <QPointer>
#include <QHash>
#include <QHttp>
#include <QBuffer>
#include <QTemporaryFile>

class UIPublicity : public fgDialog, public Ui::UIPublicity
{
	Q_OBJECT

public:
	static UIPublicity* self( const QString& size, const QUrl& url, QWidget* parent = 0 );

protected:
	void hideEvent( QHideEvent* event );

private:
	UIPublicity( QWidget* parent = 0 );
	static QPointer<UIPublicity> mSelf;

	QBuffer mBuffer, mPixmap;
	QUrl mUrl;
	QStringList images;
	QHash<QString, QTemporaryFile*> pixmaps;
	QHash<int, QString> urlPixmaps;

public slots:
	virtual void reject();
	void on_tbSource_anchorClicked( const QUrl& );
	void setMode( const QString& );
	void openUrl( const QUrl& );
	void readPage( const QByteArray&, bool );

	void requestFinished( int, bool );
	void pixmapsDone( bool );

signals:
	void hidden();
};

#endif // UIPUBLICITY_H
